{
  'target_defaults': {
    'default_configuration': 'Release',
    'conditions': [
      ['OS == "win"', {
        'msbuild_toolset': 'v120',
      }], 
    ],
  },
  'targets' : [
    {
      'target_name' : 'NodeIMU',
      'sources' : [
        './addon.cpp',
        './nodeimu.cpp',
        './RTIMULib2/RTIMULib/RTMath.cpp',      
        './RTIMULib2/RTIMULib/RTIMUHal.cpp',
        './RTIMULib2/RTIMULib/RTFusion.cpp',
        './RTIMULib2/RTIMULib/RTFusionKalman4.cpp',
        './RTIMULib2/RTIMULib/RTFusionRTQF.cpp',
        './RTIMULib2/RTIMULib/RTIMUSettings.cpp',
        './RTIMULib2/RTIMULib/RTIMUAccelCal.cpp',
        './RTIMULib2/RTIMULib/RTIMUMagCal.cpp',  
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMU.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUNull.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUMPU9150.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUMPU9250.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUGD20HM303D.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUGD20M303DLHC.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUGD20HM303DLHC.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMULSM9DS0.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMULSM9DS1.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUBMX055.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTIMUBNO055.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTPressure.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTPressureBMP180.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTPressureLPS25H.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTPressureMS5611.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTPressureMS5637.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTHumidity.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTHumidityHTS221.cpp',
        './RTIMULib2/RTIMULib/IMUDrivers/RTHumidityHTU21D.cpp'
      ],
      'include_dirs': [
        './RTIMULib2/RTIMULib',
         "<!(node -e \"require('nan')\")"
      ]
    },
    {
       # needed for publishing binaries with node-pre-gyp
       'target_name': 'action_after_build',
       'type': 'none',
       'dependencies': [ 'NodeIMU' ],
       'copies': [{
          'files': [ '<(PRODUCT_DIR)/NodeIMU.node' ],
          'destination': './out/'
       }]
     }
  ]
}
